std::filesystem::create_symlink,std::filesystem::create_directory_symlink(3)

NAME
std::filesystem::create_symlink,std::filesystem::create_directory_symlink - std::filesystem::create_symlink,std::filesystem::create_directory_symlink

Synopsis
   Defined in header <filesystem>
   void create_symlink( const std::filesystem::path& target,
   const std::filesystem::path& link );
   void create_symlink( const std::filesystem::path& target, (1) (since C++17)
   const std::filesystem::path& link,
   std::error_code& ec ) noexcept;
   void create_directory_symlink( const std::filesystem::path&
   target,
   const std::filesystem::path& link );
   void create_directory_symlink( const std::filesystem::path& (2) (since C++17)
   target,
   const std::filesystem::path& link,
   std::error_code& ec ) noexcept;
   Creates a symbolic link link with its target set to target as if by POSIX symlink():
   the pathname target may be invalid or non-existing.
   Some operating systems require symlink creation to identify that the link is to a
   directory. Portable code should use (2) to create directory symlinks rather than
   (1), even though there is no distinction on POSIX systems.

Parameters
   target - path to point the symlink to, does not have to exist
   link - path of the new symbolic link
   ec - out-parameter for error reporting in the non-throwing overload

Return value
   (none)

Exceptions
   The overload that does not take a std::error_code& parameter throws
   filesystem::filesystem_error on underlying OS API errors, constructed with target as
   the first path argument, link as the second path argument, and the OS error code as
   the error code argument. The overload taking a std::error_code& parameter sets it to
   the OS API error code if an OS API call fails, and executes ec.clear() if no errors
   occur. Any overload not marked noexcept may throw std::bad_alloc if memory
   allocation fails.

Notes
   Some operating systems do not support symbolic links at all or support them only for
   regular files.
   Some file systems do not support symbolic links regardless of the operating system,
   for example the FAT system used on some memory cards and flash drives.
   Like a hard link, a symbolic link allows a file to have multiple logical names. The
   presence of a hard link guarantees the existence of a file, even after the original
   name has been removed. A symbolic link provides no such assurance; in fact, the file
   named by the target argument need not exist when the link is created. A symbolic
   link can cross file system boundaries.

Example
// Run this code
 #include <iostream>
 #include <filesystem>
 #include <cassert>
 namespace fs = std::filesystem;
 int main()
 {
     fs::create_directories("sandbox/subdir");
     fs::create_symlink("target", "sandbox/sym1");
     fs::create_directory_symlink("subdir", "sandbox/sym2");
     for(auto it = fs::directory_iterator("sandbox"); it != fs::directory_iterator(); ++it)
         if(is_symlink(it->symlink_status()))
             std::cout << *it << "->" << read_symlink(*it) << '\n';
     assert( std::filesystem::equivalent("sandbox/sym2", "sandbox/subdir") );
     fs::remove_all("sandbox");
 }

Possible output:
 "sandbox/sym1"->"target"
 "sandbox/sym2"->"subdir"

See also
   status determines file attributes
   symlink_status determines file attributes, checking the symlink target
   (C++17) (function)
   (C++17)
   read_symlink obtains the target of a symbolic link
   (C++17) (function)
   create_hard_link creates a hard link
   (C++17) (function)